UsePNGImageDecoder()
UseJPEGImageDecoder()
UseOGGSoundDecoder()
UseTGAImageDecoder()
UseTIFFImageDecoder()

;----CONSTANTS

   #D3DBLEND_ZERO            = 1
   #D3DBLEND_ONE             = 2
   #D3DBLEND_SRCCOLOR        = 3
   #D3DBLEND_INVSRCCOLOR     = 4
   #D3DBLEND_SRCALPHA        = 5
   #D3DBLEND_INVSRCALPHA     = 6
   #D3DBLEND_DESTALPHA       = 7
   #D3DBLEND_INVDESTALPHA    = 8
   #D3DBLEND_DESTCOLOR       = 9
   #D3DBLEND_INVDESTCOLOR    = 10
   #D3DBLEND_SRCALPHASAT     = 11
   #D3DBLEND_BOTHSRCALPHA    = 12
   #D3DBLEND_BOTHINVSRCALPHA = 13
   
   
   
   
Enumeration
 #ERROR_UNKNOWN
 #ERROR_INIT_IO
 #ERROR_INIT_2D_GFX
 #ERROR_INIT_3D_GFX 
 #ERROR_INIT_UI
 #ERROR_INIT_INIT
 #ERROR_OPEN_DEVELOPER_WINDOW
 #ERROR_OPEN_WORLD_SCREEN
 #MOUSE
 #KEYBOARD 
 #STICK 
 #TOUCH 
 #MULTICONTROL 
 #REGION
 #MAP
 #FOLLOW
 #FLEE
 #ATTACK
 ;special effects /blittersystem for screenmanipulation
 #AREAFADEOUT
 #AREAFADEIN
 #SWITCHCUBUS
 #AREAFADEOUTLOOP
 #AREAFADEINLOOP
 #HORIZONTAL_MOVE
 #VERTICAL_MOVE
 #MOVE_UP   ;for internal use  (anim frame system version 191211)
 #MOVE_DOWN
 #MOVE_LEFT 
 #MOVE_RIGHT 
 EndEnumeration 
 



;--
Global _mode.l=0
Global _reset_fade_in.b=1
Global _init_special_screen.b=0
Global _no_mirror.b=0 ;switch mirror effect on/off...for performance issues
Global _app_mode$="REGION" ;default
Global _app_mode_.b=#REGION ;default
Global _ver$="VERSION INFO MISSING"
Global _usr_scroll.b=0
Global _dx1.b=0
Global _dx2.b=0
Global _gridIsScaled=0  ;workaround for the scaler to scale _grid only one time! (1=allready scaled!!!!)
Global _scale=0
Global _level_path$=""
Global _maxworldftile=0
Global _error_code.b=0
Global Dim _error_text$(10)
Global _core$=GetCurrentDirectory()+"\CORE\"
Global _mywindow.l=0
Global _event.l=0
Global _key$=""
Global _value$=""
Global _file_ID=0
Global _ioID=0  ;for I/O 
Global _system_text_base$=""
Global _atom$=""
Global _matrix_size.l=0
Global _matrix_area.l=0
Global _grid_width.f=0
Global _grid_height.f=0
Global _grid_offset_x.f=0
Global _grid_offset_y.f=0
Define dummy.l=ExamineDesktops()
Global _screen_w.f=DesktopWidth(0)   ;use OS desktopdimensions and parameters
Global _screen_h.f=DesktopHeight(0)
Global _screen_d.b=DesktopDepth(0)
Global _screen_f.l=DesktopFrequency(0)
Global _screenID.l=0
Global _global_time.l=ElapsedMilliseconds()
Global _start_time.l=_global_time
Global _grid_R.l=255
Global _grid_G.l=0
Global _grid_B.l=0
Global _hit_x.l
Global _hit_y.l=0
Global _mouse_x.f=0
Global _mouse_y.f=0
Global _l_mouse.b=0
Global _r_mouse.b=0
Global _usr_x.f=0
Global _usr_y.f=0
Global _usr_x1.f=0
Global _usr_y2.f=0
Global _debug_mode=0
Global _debug_object_ID$=""
Global _true.b=0  ;dummy variable 
Global _dpointer.l=0
Global _joy_x.b=0 ;joypad direction
Global _joy_y.b=0
Global _joy_b.b=0 ;joystiuck button
Global _joy_pad.b=#False  ;no joypad?!
Global _screen_smooth.b=0 ;used for own smoothing routine
Global _screen_sprite2D.l=0
Global _screen_sprite3D.l=0 ;used for the smoothing....
Global _multitask.b=#False
Global _multitask_backup.b=0
Global _fileLoadMusic.l=0
Global _fileLoadMusicFile.s=""
Global _map_x_max.l;global variable to hold the maximum x dimension  of map, for manipulation issue
Global _map_y_max.l;global variable to hold the maximum y dimension  of map, for manipulation issue
Global _level_switch.l=0  ;used for automatic screen change (credits..intro...)
Global _level_switch_base.l=0 ;used for automatic screen change (credits..intro...)
Global _bloom.b=0
Global _inwarn.s=""
Global _gui_path.s=""



;SERVERSECTION FOR SERVER/ONLINE MODE OF INGRID ENGINE; USED TO KEEP GAMEPLAY AT LATEST/ACTUAL STATE
 


 Global i_2dgfx_path$
 Global i_fileLoadMusicFile$
 Global i_anim_path$
 Global i_sound_path$
 Global i_level_path$
 Global _hello$=""
 Global _temp$=""
 Global _web_io_finished.b=0
 Global i_gfx$=""

;**********************************

Global _in_grid_settings.s=""


;some developement internals:
Global FR=0
Global FRt=1000
Global FR$=""

;END

;display handling / gfx sw screenscaler ...for "__REALTIMESCALER() in FWORLD
Global _3D_game_screen.l=0  ; holds the 3Dgfx (grabsprite)
Global _2D_game_screen.l=0  ;holds the "2D" gfx ....
Global _pip.b=0 ;PIP
Global _ob.l=0 ;lazarussystem
;--FILE HANDLING
Global _clear_screen.b =#True
Global _codec_path$=""
Global _sound_codec$=""
Global _music_codec$=""
Global _sound_path$=""
Global _gfx_codec$=""
Global _codec$=""
Global _2dgfx_path$=""
Global _2d_effect_gfx_path.s=""
Global _gfx_path$=""
Global tile_reset.b=0
Global descriptortile$=""
Global _errorGFX.l=0
Global _ok.l=0
Global _dType$=""
Global _dValue$=""
Global _i.l=0
Global _j.l=0
Global _worldftile.l=0
Global menuItemMax.l=0
Global _scr_scaleX.f=1
Global _scr_scaleY.f=1
Global _width.f=1
Global _height.f=1
Global _defWidth.f=1
Global _defHeight.f=1
Global _aspectFactor.f=1
Global _aspectCorr.f=1
Global _aspectFactorstring$=""
Global _hor.f=1
Global _app_entry_point.l=0 ;default if no valid entrypoint is found
Global _brain_skript.s=""
;some LUCY-RETIOSCALER vars no more need in MATRIXBUILDER/MATRIXENGINE
Global _newheight.f=1
Global _boxHeight.f=1  ;from LUCY...
; Global _topBoxX.f=0
; Global _topBoxY.f=0
; Global _topBoxH.f=0
; Global _topBoxW.f=0
; Global _botBoxX.f=0
; Global _botBoxY.f=0
; Global _botBoxH.f=0
; Global _botBoxW.f=0
; Global _botBoxH.f=0
Global _w.f=0
Global _h.f=0
;----------------------------------------------------------
Global _show_mini_map.b=0 ;internal use for realtime minimap of the level.... ;default key= "M" on keyboard, or  "Select" on joystick/pad
Global _map_scale_x.f=1 ;used for minimap system
Global _map_scale_y.f=1 ;used for minimapsystem
Global _global_pause=0 ;the global pausefunction
Global _dynamic_scroll.b=0
Global _scrscx$=""
Global _scrscy$=""
Global _maxUsedLayer=0


   Global _vwait=1  ;engine waits for screensync: default setting: override it with the ssystemininscript

 Structure  _font
 _fontX.f
 _fontY.f
 _fontH.f
 _fontW.f
 _font2DGFXID.l
 _font3DGFXID.l
 _fontSRC.s  ;holds the "FONTOBJECT NAME" ("A","B"....)
 _fontValid.b  ;if <>0 we can use it, soi we do not need to check for the big 2D/3D Values...
 EndStructure
 
 
 Global Dim MyFont._font(255)  ;dim= Max Font/Objects=CHAR/ASCCODE
 Global _fontFundament.s=""  ;stores the fontstring destination ("ABCDEFGHIJKLMNOPQRSTUVWXYZ......") defined in the iniscript
 Global _font.s=""
 ;some actions for my fonsystem:
 Global _user_key=0
 
 Enumeration
 #FROTATE_YES
 #FROTATE_NO
 EndEnumeration







; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 247
; FirstLine = 209
; Folding = -
; EnableXP
; EnableOnError
; Executable = warpzone_040611.exe
; CPU = 5
; DisableDebugger